<?php

	// Dismiss Session
	PHPVC_SESSION::VAR_STOP();
	
	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	
	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_CAT_CUSTOM_ID',
					'PARAM_CAT_CUSTOM_URL',
					'PARAM_CAT_CUSTOM_CODE',
					'PARAM_CAT_CUSTOM_DESCRIPTION',
					'PARAM_CAT_CUSTOM_LSTRING',
					'PARAM_CAT_CUSTOM_SSTRING',
					'PARAM_CAT_CUSTOM_BIGINT_FROM',
					'PARAM_CAT_CUSTOM_BIGINT_TO',
					'PARAM_CAT_CUSTOM_MODIFY_DATE_FROM',
					'PARAM_CAT_CUSTOM_MODIFY_DATE_TO',
					'PARAM_CAT_CUSTOM_ACC_ACCOUNT_ID',
					'PARAM_CAT_CUSTOM_ACC_LEVEL_ID',
					'PARAM_CAT_CUSTOM_STATUS',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_CAT_CUSTOM_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_CAT_CUSTOM_ID');
			$PARAM_CAT_CUSTOM_URL = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_CUSTOM_URL');
			$PARAM_CAT_CUSTOM_CODE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_CUSTOM_CODE');
			$PARAM_CAT_CUSTOM_DESCRIPTION = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_CUSTOM_DESCRIPTION');
			$PARAM_CAT_CUSTOM_LSTRING = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_CUSTOM_LSTRING');
			$PARAM_CAT_CUSTOM_SSTRING = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_CUSTOM_SSTRING');
			$PARAM_CAT_CUSTOM_BIGINT_FROM = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_CAT_CUSTOM_BIGINT_FROM');
			$PARAM_CAT_CUSTOM_BIGINT_TO = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_CAT_CUSTOM_BIGINT_TO');
			$PARAM_CAT_CUSTOM_MODIFY_DATE_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_CAT_CUSTOM_MODIFY_DATE_FROM');
			$PARAM_CAT_CUSTOM_MODIFY_DATE_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_CAT_CUSTOM_MODIFY_DATE_TO');
			$PARAM_CAT_CUSTOM_ACC_ACCOUNT_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_CAT_CUSTOM_ACC_ACCOUNT_ID');
			$PARAM_CAT_CUSTOM_ACC_LEVEL_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_CAT_CUSTOM_ACC_LEVEL_ID');
			$PARAM_CAT_CUSTOM_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_CAT_CUSTOM_STATUS');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'CAT_CUSTOM_ID', 
						'CAT_CUSTOM_URL', 
						'CAT_CUSTOM_CODE', 
						'CAT_CUSTOM_DESCRIPTION', 
						'CAT_CUSTOM_LSTRING', 
						'CAT_CUSTOM_SSTRING', 
						'CAT_CUSTOM_BIGINT', 
						'CAT_CUSTOM_MODIFY_DATE', 
						'CAT_CUSTOM_ACC_ACCOUNT_ID', 
						'CAT_CUSTOM_ACC_LEVEL_ID', 
						'CAT_CUSTOM_STATUS'
						, 
						'ACC_ACCOUNT_ID',		
						'ACC_ACCOUNT_SERVER_ID',		
						'ACC_ACCOUNT_ACC_LEVEL_ID',		
						'ACC_ACCOUNT_ACC_GROUP_ID',		
						'ACC_ACCOUNT_ADD_RESOURCE_ID',		
						'ACC_ACCOUNT_USERNAME',		
						'ACC_ACCOUNT_PASSWORD',		
						'ACC_ACCOUNT_AUTH_CODE',		
						'ACC_ACCOUNT_FIRST_NAME',		
						'ACC_ACCOUNT_MIDDLE_NAME',		
						'ACC_ACCOUNT_LAST_NAME',		
						'ACC_ACCOUNT_POSITION',		
						'ACC_ACCOUNT_SYS_GENDER_ID',		
						'ACC_ACCOUNT_STATUS',		
						'ACC_ACCOUNT_SYSTEM_GENERATED',		
						'ACC_LEVEL_ID',		
						'ACC_LEVEL_SERVER_ID',		
						'ACC_LEVEL_TAG_ID',		
						'ACC_LEVEL_DESCRIPTION',		
						'ACC_LEVEL_LANDING_PAGE',		
						'ACC_LEVEL_STATUS',		
						'ACC_LEVEL_SYSTEM_GENERATED'		
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_CATEGORY_CUSTOMIZE::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_CAT_CUSTOM_ID'] = $PARAM_CAT_CUSTOM_ID;
			$GET_MAP_ARRAY['PARAM_CAT_CUSTOM_URL'] = $PARAM_CAT_CUSTOM_URL;
			$GET_MAP_ARRAY['PARAM_CAT_CUSTOM_CODE'] = $PARAM_CAT_CUSTOM_CODE;
			$GET_MAP_ARRAY['PARAM_CAT_CUSTOM_DESCRIPTION'] = $PARAM_CAT_CUSTOM_DESCRIPTION;
			$GET_MAP_ARRAY['PARAM_CAT_CUSTOM_LSTRING'] = $PARAM_CAT_CUSTOM_LSTRING;
			$GET_MAP_ARRAY['PARAM_CAT_CUSTOM_SSTRING'] = $PARAM_CAT_CUSTOM_SSTRING;
			$GET_MAP_ARRAY['PARAM_CAT_CUSTOM_BIGINT_FROM'] = $PARAM_CAT_CUSTOM_BIGINT_FROM;
			$GET_MAP_ARRAY['PARAM_CAT_CUSTOM_BIGINT_TO'] = $PARAM_CAT_CUSTOM_BIGINT_TO;
			$GET_MAP_ARRAY['PARAM_CAT_CUSTOM_MODIFY_DATE_FROM'] = $PARAM_CAT_CUSTOM_MODIFY_DATE_FROM;
			$GET_MAP_ARRAY['PARAM_CAT_CUSTOM_MODIFY_DATE_TO'] = $PARAM_CAT_CUSTOM_MODIFY_DATE_TO;
			$GET_MAP_ARRAY['PARAM_CAT_CUSTOM_ACC_ACCOUNT_ID'] = $PARAM_CAT_CUSTOM_ACC_ACCOUNT_ID;
			$GET_MAP_ARRAY['PARAM_CAT_CUSTOM_ACC_LEVEL_ID'] = $PARAM_CAT_CUSTOM_ACC_LEVEL_ID;
			$GET_MAP_ARRAY['PARAM_CAT_CUSTOM_STATUS'] = $PARAM_CAT_CUSTOM_STATUS;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_CATEGORY_CUSTOMIZE::CUS_GET_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{		
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>